## mshr 2018.1.0+dfsg1

=== CMakeLists.txt ===
# Require CMake 3.5
cmake_minimum_required(VERSION 3.5)

project( MSHR )
set(MSHR_VERSION_RELEASE 1)
set(MSHR_VERSION_MAJOR "2018")
set(MSHR_VERSION_MINOR "1")
set(MSHR_VERSION_MICRO "0")
set(MSHR_VERSION "${MSHR_VERSION_MAJOR}.${MSHR_VERSION_MINOR}.${MSHR_VERSION_MICRO}")
if (NOT MSHR_VERSION_RELEASE)
  set(MSHR_VERSION "${MSHR_VERSION}.dev0")
endif()

# CGAL setup
option(USE_SYSTEM_CGAL "Do not build CGAL, but use an existing build instead." OFF)
if (USE_SYSTEM_CGAL)
  find_package(CGAL 4.12 CONFIG REQUIRED)
endif()

# Borrow some cmake modules from cgal
if (USE_SYSTEM_CGAL)
  set(CMAKE_MODULE_PATH "${CGAL_MODULES_DIR}")
else()
  set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/3rdparty/CGAL/cmake/modules")
endif()

# Add cmake directory to module path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

option(USE_SYSTEM_TETGEN "Do not build tetgen, but use an existing build instead." OFF)
if (USE_SYSTEM_TETGEN)
  find_package(TetGen)
endif()

# Helper macro for testing if particular value is contained in list
# Taken from http://www.cmake.org/Wiki/CMakeMacroListOperations#LIST_CONTAINS
MACRO(LIST_CONTAINS var value)
  SET(${var})
  FOREACH (value2 ${ARGN})
    IF (${value} STREQUAL ${value2})
      SET(${var} TRUE)
    ENDIF (${value} STREQUAL ${value2})
  ENDFOREACH (value2)
ENDMACRO(LIST_CONTAINS)

# Use C++11
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall")

# Boost
# This is workaround to avoid that find_package(Boost)
# picks up th ewrong boost when a hint is given
set(BOOST_ROOT $ENV{BOOST_DIR} $ENV{BOOST_HOME})
if (BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS on)
endif()

# Prevent FindBoost.cmake from looking for system Boost{foo}.cmake files
set(Boost_NO_BOOST_CMAKE true)
find_package( Boost REQUIRED system filesystem program_options )
# Save this because it will be overwritten by find_package(DOLFIN)
set(Boost_MSHR_LIBRARIES ${Boost_LIBRARIES})
include_directories("${Boost_INCLUDE_DIRS}")

#  GMP_INCLUDE_DIR       - the GMP include directory
#  GMP_LIBRARIES_DIR     - directory where the GMP libraries are located
#  GMP_LIBRARIES         - Link these to use GMP
find_package(GMP REQUIRED)
include_directories("${GMP_INCLUDE_DIR}")

# Try to find the MPFR libraries
# MPFR_FOUND - system has MPFR lib
# MPFR_INCLUDE_DIR - the MPFR include directory
# MPFR_LIBRARIES_DIR - Directory where the MPFR libraries are located
# MPFR_LIBRARIES - the MPFR libraries
# MPFR_IN_CGAL_AUXILIARY - TRUE if the MPFR found is the one distributed with CGAL in the auxiliary folder
find_package(MPFR REQUIRED)
include_directories("${MPFR_INCLUDE_DIR}")

find_package(Eigen3 REQUIRED)
include_directories("${EIGEN3_INCLUDE_DIR}")

# use CGAL in header-only mode
option (CGAL_HEADER_ONLY "Use CGAL in header-only mode" ON)
if (CGAL_HEADER_ONLY)
  add_definitions( -DCGAL_HEADER_ONLY )
endif()

add_subdirectory(3rdparty)
#include_directories(BEFORE ${CGAL_INCLUDE_DIR})
include_directories(BEFORE ${EXTERNAL_INCLUDE_DIRS})
add_definitions("${EXTERNAL_DEFINITIONS}")

find_package(DOLFIN REQUIRED)
include_directories(${DOLFIN_PYTHON_INCLUDE_DIRS})
include(${DOLFIN_USE_FILE})

# Set installation directories
set(INSTALL_LIB_DIR lib CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR bin CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR include CACHE PATH "Installation directory for header files")
set(SHARE_DIR "share/mshr" CACHE PATH "Shared data installation directory.")

# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
  set(var INSTALL_${p}_DIR)
  if(NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif()
endforeach()


# include for local header directory
include_directories( BEFORE include )

file( GLOB_RECURSE SOURCES src/*.cpp )

add_library(mshr SHARED ${SOURCES})
if (NOT USE_SYSTEM_CGAL)
  add_dependencies( mshr CGAL )
endif()

# Append the library version information to the library target properties
option(MSHR_WITH_LIBRARY_VERSION "Build with library version information." ON)
if (MSHR_WITH_LIBRARY_VERSION)
  string(REPLACE "+" "" MSHR_LIBRARY_VERSION ${MSHR_VERSION})
  # This setting of SOVERSION assumes that any API change
  # will increment either the minor or major version number.
  set(MSHR_LIBRARY_PROPERTIES ${MSHR_LIBRARY_PROPERTIES}
    VERSION ${MSHR_LIBRARY_VERSION}
    SOVERSION ${MSHR_VERSION_MAJOR}.${MSHR_VERSION_MINOR}
  )
endif()
set_target_properties(mshr PROPERTIES ${MSHR_LIBRARY_PROPERTIES})

# Link the executable to (static) CGAL libraries
target_link_libraries( mshr ${Boost_MSHR_LIBRARIES}
                            ${GMP_LIBRARIES}
                            ${MPFR_LIBRARIES}
			    tet
                            ${DOLFIN_LIBRARIES}
                     )

# Fix CGAL's random generator (usefull to reproduce bugs)
option(INIT_CGAL_RANDOM "Use fixed seed for CGAL's pseudo random generator" OFF)
if (INIT_CGAL_RANDOM)
  add_definitions( -DINIT_RANDOM_GENERATOR=0 )
endif()

#
option(ENABLE_EXPERIMENTAL "Enable experimental code" OFF)
if(ENABLE_EXPERIMENTAL)
  message(STATUS "Enabling experimental code")
  add_definitions( -DMSHR_ENABLE_EXPERIMENTAL )
endif()


export(PACKAGE mshr)

target_link_libraries( mshr
  ${DOLFIN_LIBRARIES}
  ${Boost_MSHR_LIBRARIES}
  )

# install library
install(TARGETS mshr
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR}
  ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
  )

option(ENABLE_MSHRABLE "Enable building the command line client, mshrable" OFF)
if (ENABLE_MSHRABLE)
  add_executable( mshrable app/mshrable.cpp )

  target_link_libraries( mshrable
    mshr
    ${DOLFIN_LIBRARIES}
    ${Boost_MSHR_LIBRARIES}
    )

  # install app
  install(TARGETS mshrable
    RUNTIME DESTINATION ${INSTALL_BIN_DIR}
    LIBRARY DESTINATION ${INSTALL_LIB_DIR}
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
    )
else()
    message(STATUS "Disabling building command line client mshrable")
endif()

# install header files
install(DIRECTORY include/ DESTINATION ${INSTALL_INCLUDE_DIR})

file(RELATIVE_PATH REL_INCLUDE_DIR "${INSTALL_CMAKE_DIR}" "${INSTALL_INCLUDE_DIR}")

### add cmake configuration file ###

# common for both config files
set(CONF_EXTERNAL_INCLUDE_DIRS "${DOLFIN_PYTHON_INCLUDE_DIRS};${DOLFIN_INCLUDE_DIRS};${DOLFIN_3RD_PARTY_INCLUDE_DIRS}")
set(CONF_EXTERNAL_LIBRARIES "${DOLFIN_PYTHON_LIBRARIES};${DOLFIN_LIBRARIES};${DOLFIN_3RD_PARTY_LIBRARIES}")
set(CONF_CXX_DEFINITIONS "${DOLFIN_CXX_DEFINITIONS}")
string(REPLACE "\"" "\\\"" CONF_CXX_DEFINITIONS "${CONF_CXX_DEFINITIONS}")
set(CONF_CXX_FLAGS "${DOLFIN_CXX_FLAGS}")

# for the build tree
set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
set(CONF_LIBRARIES_DIRS "${PROJECT_BINARY_DIR}")

configure_file(mshrConfig.cmake.in "${PROJECT_BINARY_DIR}/mshrConfig.cmake" @ONLY)
configure_file(mshr-config.cmake.in "${PROJECT_BINARY_DIR}/mshr-config.cmake" @ONLY)

# ... and for the install tree
set(CONF_INCLUDE_DIRS "${INSTALL_INCLUDE_DIR}")
set(CONF_LIBRARIES_DIRS "${INSTALL_LIB_DIR}")
configure_file(mshrConfig.cmake.in
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshrConfig.cmake" @ONLY)
configure_file(mshr-config.cmake.in
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshr-config.cmake" @ONLY)

# Install the FooBarConfig.cmake and FooBarConfigVersion.cmake
install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshrConfig.cmake" DESTINATION "${SHARE_DIR}/cmake" COMPONENT dev)
install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshr-config.cmake" DESTINATION "${SHARE_DIR}/cmake" COMPONENT dev)
#install(FILES "Use-mshr.cmake" DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)





option(ENABLE_TESTS "Enable testing" OFF)

if(ENABLE_TESTS)
  enable_testing()
  add_subdirectory(test)
else()
  message(STATUS "Testing disabled")
endif()

=== debian/changelog ===
mshr (2018.1.0+dfsg1-7) unstable; urgency=medium

  * Debian patch fix_mesh3_internal.patch updates namespace for
    Mesh_3::internal::C3t3_initializer (CGAL 4.13). Closes: #911814.

 -- Drew Parsons <dparsons@debian.org>  Fri, 26 Oct 2018 11:45:58 +0800

mshr (2018.1.0+dfsg1-6) unstable; urgency=medium

  * apply strict versioned depends on pybind11,
    python3-mshr Depends: pybind11 (>= 2.2.4), pybind11 (<= 2.2.5)

 -- Drew Parsons <dparsons@debian.org>  Tue, 25 Sep 2018 04:04:24 +0800

mshr (2018.1.0+dfsg1-5) unstable; urgency=medium

  * strip -g from dpkg-buildflags to reduce memory requirements of the
    build (needed to build on Debian 32 bit and on ubuntu)
  * Standards-Version: 4.2.1

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Sep 2018 21:25:48 +0800

mshr (2018.1.0+dfsg1-4) unstable; urgency=medium

  * fix debian/tests: demos are now provided by python3-mshr

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 Aug 2018 22:42:56 +0800

mshr (2018.1.0+dfsg1-3) unstable; urgency=medium

  * run autopkgtest on demos from mshr-demos package
    - install demos in /usr/share/doc/mshr-demos/examples
  * mark libmshr2018.1 as Multi-Arch: same
  * drop mshr-demos (FTBFS on i386 interferes with package migration)
    and install demos with python3-mshr.

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 Aug 2018 02:47:12 +0800

mshr (2018.1.0+dfsg1-2) unstable; urgency=medium

  * Upload to unstable. Closes: #905369.
  * Standards-Version: 4.2.0
  * Build-Depends: python3-setuptools
  * Add debian/tests (autopkgtest)
    - debian patch test_controls.diff provides test.py scripts

 -- Drew Parsons <dparsons@debian.org>  Sat, 04 Aug 2018 13:31:48 +0800

mshr (2018.1.0+dfsg1-1exp1) experimental; urgency=medium

  * New upstream release.
    - debian patches applied upstream:
      cgal_4.12.patch
      tetgen_define_TETLIBRARY.patch
      use_system_cgal_tetgen.patch
    - removes python2 support (python-mshr is dropped)
    - uses pybind11 instead of swig
  * debian patch cmake_config_in_lib.patch places cmake config files
    in lib not share, since MSHR_LIBRARIES_DIRS is arch-specific.
  * apply dpkg-buildflags CXXFLAGS to cmake build (for hardening and
    debug symbols)
  * remove CGAL and tetgen licences from debian/copyright (these
    3rdParty sources have been removed from the source tarball)
  * Standards-Version: 4.1.5
  * Build-Depends: python3-all-dev (i.e. add python3.7 support)

 -- Drew Parsons <dparsons@debian.org>  Tue, 10 Jul 2018 13:07:08 +0800

mshr (2017.2.0+dfsg1-1) unstable; urgency=medium

  * Upload mshr without embedded CGAL and tetgen code. Closes: #824716.
  * debian/copyright Files-Excluded: 3rdparty/CGAL 3rdparty/tetgen1.5.0
    CGAL and tetgen are provided by their own packages, so exclude
    them from mshr to save space.
  * Debian patch cgal_4.12.patch builds against CGAL 4.12.
  * Build against system CGAL and tetgen.
    Thanks Johannes Ring (upstream branch
    johannr/optional-use-system-packages, applied as Debian patch
    use_system_cgal_tetgen.patch)
    - Build-Depends: libcgal-dev (>= 4.12), libtet1.5-dev.
    - debian patch tetgen_define_TETLIBRARY.patch ensures tetgen
      library API is used (defines TETLIBRARY)
  * Build-Depends: cmake (>= 3.5)
  * Standards-Version: 4.1.4
  * Debian patch demos_update.patch keeps extrude demo running

 -- Drew Parsons <dparsons@debian.org>  Wed, 23 May 2018 03:10:08 +0800

mshr (2017.2.0-1) UNRELEASED; urgency=medium

  * Team upload.
  * New upstream version.
  * Standards-Version: 4.1.3
  * debhelper compatibility level 11

 -- Drew Parsons <dparsons@debian.org>  Thu, 25 Jan 2018 16:59:08 +0800

mshr (2017.1.0-2) UNRELEASED; urgency=medium

  * Team upload.
  * Standards-Version: 4.1.2
  * Provide python3 support in python3-mshr

 -- Drew Parsons <dparsons@debian.org>  Tue, 12 Dec 2017 14:56:09 +0800

mshr (2017.1.0-1) UNRELEASED; urgency=medium

  * Team upload.

  [ Johannes Ring ]
  * New upstream release.
    - Move debian/libmshr2016.2.install > debian/libmshr2017.1.install.
    - Update package name for new SONAME 2017.1 (libmshr2016.2 ->
      libmshr2017.1).
    - Bump minimum required version of libdolfin-dev, python-ffc,
      python-dolfin and dolfin-bin from 2016.2.0 to 2017.1.0.

  [ Drew Parsons ]
  * Standards-Version: 4.1.0
  * debhelper compatibility level 10

 -- Johannes Ring <johannr@simula.no>  Thu, 11 May 2017 13:04:50 +0200

mshr (2016.2.0-1) UNRELEASED; urgency=medium

  * New upstream release.
    - Move debian/libmshr2016.1.install > debian/libmshr2016.2.install.
    - Update package name for new SONAME 2016.2 (libmshr2016.1 ->
      libmshr2016.2).
    - Bump minimum required version of libdolfin-dev, python-ffc,
      python-dolfin and dolfin-bin from 2016.1.0 to 2016.2.0.

 -- Johannes Ring <johannr@simula.no>  Fri, 02 Dec 2016 15:22:32 +0100

mshr (2016.1.0-2) UNRELEASED; urgency=medium

  * New upstream release.
  * debian/control:
    - Update package name for new SONAME 2016.1 (libmshr1.6 ->
      libmshr2016.1).
    - Bump minimum required version of libdolfin-dev, python-ffc,
      python-dolfin and dolfin-bin from 1.6.0 to 2016.1.0.
    - Add libproj-dev to Build-Depends and to Depends for binary package
      libmshr-dev.
  * Move debian/libmshr1.6.install -> debian/libmshr2016.1.install.
  * Remove patch (fixed upstream).
  * debian/rules: Add -fpermissive to CXX flags.

 -- Johannes Ring <johannr@simula.no>  Fri, 02 Dec 2016 15:20:19 +0100

mshr (1.6.0-1) unstable; urgency=low

  [ Johannes Ring ]
  * Initial release (Closes: #824716)

  [ Drew Parsons ]
  * Team upload.

 -- Drew Parsons <dparsons@debian.org>  Fri, 20 May 2016 08:23:26 +0800

=== debian/control ===
Source: mshr
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Johannes Ring <johannr@simula.no>, Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper (>= 11),
 python3-all-dev,
 dh-python,
 python3-setuptools,
 cmake (>= 3.5),
 python3-pybind11 (>= 2.2.2),
 libmpfr-dev,
 libgmp-dev,
 libcgal-dev (>= 4.13),
 libtet1.5-dev,
 libdolfin-dev (>= 2018.1),
 python3-ffc (>= 2018.1),
 python3-numpy,
 python3-petsc4py,
 python3-slepc4py,
 libproj-dev
Standards-Version: 4.2.1
X-Python3-Version: >= 3.5
Homepage: http://fenicsproject.org
Vcs-Git: https://salsa.debian.org/science-team/fenics/mshr.git
Vcs-Browser: https://salsa.debian.org/science-team/fenics/mshr

Package: libmshr2018.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shared libraries for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the shared libraries.

Package: libmshr-dev
Section: libdevel
Architecture: any
Depends: libmshr2018.1 (= ${binary:Version}),
 libdolfin-dev (>= ${fenics:Upstream-Version}),
 python3-ffc (>= ${fenics:Upstream-Version}),
 cmake (>= 2.8.0),
 libproj-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Shared links and header files for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the development files.

Package: python3-mshr
Section: python
Architecture: any
Depends: libmshr-dev (= ${binary:Version}),
 libmshr2018.1 (= ${binary:Version}),
 python3-dolfin (>= ${fenics:Upstream-Version}),
 dolfin-bin (>= ${fenics:Upstream-Version}),
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 ${python3:Depends},
 ${shlibs:Depends}, 
 ${misc:Depends}
Description: Python 3 interface for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the Python 3 interface for mshr, and examples
 and demo programs.

=== debian/rules ===
#!/usr/bin/make -f

# FIXME: Is this needed?
#CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
#CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
#CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
#LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)

MSHR_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS)

DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
FENICS_MINOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )

# dolfin has a strict dependency on the pybind11 version it was built against,
# if pybind11.h will be used in C++ code fragments in python scripts.
# Extract pybind11 version from pybind11-dev
PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
# extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
PYBIND11_Z_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\2/")
PYBIND11_NEXT_UPSTREAM_VERSION=$(PYBIND11_X_Y_VERSION).$(shell echo $$(( $(PYBIND11_Z_VERSION) + 1 )) )

# strip -g from dpkg-buildflags to reduce memory requirements of the build (needed to build on Debian 32 bit and on ubuntu)
CMAKE_OPTS := \
	-D CMAKE_BUILD_TYPE:STRING=Release \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D USE_SYSTEM_CGAL:BOOL=ON \
	-D USE_SYSTEM_TETGEN:BOOL=ON \
	-D ENABLE_MSHRABLE:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D INSTALL_LIB_DIR:PATH=lib/$(DEB_BUILD_MULTIARCH) \
	-D CMAKE_CXX_FLAGS:STRING="-fpermissive $(shell dpkg-buildflags --get CXXFLAGS | sed 's/-g //' )" \
	$(MSHR_HOME)

ifeq (,$(DISTRIBUTION))
	DISTRIBUTION := $(shell dpkg-parsechangelog --format rfc822 | sed -ne "s/^Distribution: //p")
endif

ifneq ($(DISTRIBUTION),$(findstring $(DISTRIBUTION),"squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty"))
	DISTRIBUTION := sid
endif

%:
	dh $@ --buildsystem=cmake \
	      --with python3

override_dh_auto_clean:
	dh_auto_clean
	rm -rf python/build*

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS) ;\

override_dh_auto_install:
	dh_auto_install
	set -e; \
	for v in $(PYVERS); do \
	   cd python; \
	   CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr $$v setup.py build --build-base=$(CURDIR)/python/build-$$v install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
	   cd ..; \
	done
	dh_numpy3

override_dh_gencontrol:
	dh_gencontrol -- -Vfenics:Upstream-Version=$(FENICS_VERSION) \
		-Vpybind11:Upstream-Version=$(PYBIND11_UPSTREAM_VERSION) -Vpybind11:Next-Upstream-Version=$(PYBIND11_NEXT_UPSTREAM_VERSION)

# debug symbols (-g) have been switched off in CMAKE_OPTS, so no point building dbgsym packages
override_dh_strip:
	dh_strip --no-automatic-dbgsym

#override_dh_shlibdeps:
#	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

.PHONY: get-orig-source
get-orig-source:
	uscan --force-download --verbose --destdir $(USCAN_DESTDIR)

=== debian/tests/control ===
Tests: test-mshr-python
Depends: python3-mshr,
	  python3-pytest

## mshr 2019.1.0+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 project( MSHR )
 set(MSHR_VERSION_RELEASE 1)
-set(MSHR_VERSION_MAJOR "2018")
+set(MSHR_VERSION_MAJOR "2019")
 set(MSHR_VERSION_MINOR "1")
 set(MSHR_VERSION_MICRO "0")
 set(MSHR_VERSION "${MSHR_VERSION_MAJOR}.${MSHR_VERSION_MINOR}.${MSHR_VERSION_MICRO}")

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)


# This script is used solely for getting the paths to the dependencies
# of the bindings (ie. pybind11, dolfin and mshr).
# This is written to a json file which is read from setup.py.

PROJECT(mshr_pybind11_config)


#   pybind11_FOUND - true if pybind11 and all required components found on the system
#   pybind11_VERSION - pybind11 version in format Major.Minor.Release
#   pybind11_INCLUDE_DIRS - Directories where pybind11 and python headers are located.
#   pybind11_INCLUDE_DIR - Directory where pybind11 headers are located.
#   pybind11_DEFINITIONS - Definitions necessary to use pybind11, namely USING_pybind11.
#   pybind11_LIBRARIES - compile flags and python libraries (as needed) to link against.
#   pybind11_LIBRARY - empty.
#   CMAKE_MODULE_PATH - appends location of accompanying FindPythonLibsNew.cmake and
#                       pybind11Tools.cmake modules.
find_package(pybind11 CONFIG HINTS ${PYBIND11_DIR} ${PYBIND11_ROOT}
  $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})


find_package(DOLFIN)

find_package(mshr)

configure_file("config.json.in" "config.json")

=== doc/sphinx/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/mshr.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/mshr.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/mshr"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/mshr"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/changelog ===
mshr (2019.1.0+dfsg1-7build3) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:22:32 +0100

mshr (2019.1.0+dfsg1-7build2) focal; urgency=medium

  * No change rebuild against new boost1.71 on armhf ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 17:03:21 +0000

mshr (2019.1.0+dfsg1-7build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 02 Feb 2020 20:20:48 +0100

mshr (2019.1.0+dfsg1-7) unstable; urgency=medium

  * Standards-Version: 4.5.0
  * add debian patches:
    - enable_CGAL5_CXX14.patch enables build with CGAL 5
      and builds with C++14 since std::enable_if is required by CGAL 5
    - build_CGAL5.patch updates to CGAL 5 API
    - pybind11_register.patch registers CSGCGALDomain3D::num_holes for
      python module, enabling test-fuzzypointmap.py to pass
      (update test_controls.patch)

 -- Drew Parsons <dparsons@debian.org>  Sat, 01 Feb 2020 17:14:19 +0800

mshr (2019.1.0+dfsg1-6) unstable; urgency=medium

  * stop building mips64el, mipsel with debug symbols.
    They are too fragile, often failing to build from source.

 -- Drew Parsons <dparsons@debian.org>  Mon, 21 Oct 2019 18:46:59 +0800

mshr (2019.1.0+dfsg1-5) unstable; urgency=medium

  * Standards-Version: 4.4.1
  * relax pybind11 dependency. pybind11 follows semantic versioning,
    so should be backwards compatible with minor and patch version
    updates.

 -- Drew Parsons <dparsons@debian.org>  Sun, 20 Oct 2019 19:23:41 +0800

mshr (2019.1.0+dfsg1-4) unstable; urgency=medium

  * build with dh --no-parallel to reduce memory requirements
    (to aid builds on mips,mipsel,ubuntu). Closes: #934244.

 -- Drew Parsons <dparsons@debian.org>  Sat, 10 Aug 2019 11:14:22 +0800

mshr (2019.1.0+dfsg1-3) unstable; urgency=medium

  * Standards-Version: 4.4.0
  * debian patch build_CGAL_4.14.patch enables build against CGAL 4.14
  * debian/control: remove ancient-python-version-field 3.5

 -- Drew Parsons <dparsons@debian.org>  Mon, 05 Aug 2019 17:50:52 +0800

mshr (2019.1.0+dfsg1-2) experimental; urgency=medium

  * update debian/copyright
    - Benjamin Kehlet's dates are 2012-2017
    - acknowledge Joachim B Haga and Lars Magnus Valnes
    - list contributing authors under Files: *
    - mark files licensed under LGPL-3+

 -- Drew Parsons <dparsons@debian.org>  Tue, 21 May 2019 14:11:59 +0800

mshr (2019.1.0+dfsg1-1) experimental; urgency=medium

  * New upstream release (official).

 -- Drew Parsons <dparsons@debian.org>  Thu, 25 Apr 2019 23:33:14 +0800

mshr (2019.1.0+dfsg1~2018.1.0-1) experimental; urgency=medium

  * Dummy upstream release using 2018.1.0 code to build against
    dolfin 2019.1.
  * Standards-Version: 4.3.0
  * debhelper compatibility level 12
    - skip dh_dwz since debug symbols have been switched off
      (since 2018.1.0+dfsg1-5)
  * Include debug symbols if build will be successful, only omit -g for
    arches blacklisted in ARCH_NO_DEBUG_SYMBOLS

 -- Drew Parsons <dparsons@debian.org>  Thu, 28 Mar 2019 18:25:51 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: mshr
 Section: math
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Johannes Ring <johannr@simula.no>, Drew Parsons <dparsons@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
  python3-all-dev,
  dh-python,
  python3-setuptools,
@@ -13,19 +14,18 @@
  libgmp-dev,
  libcgal-dev (>= 4.13),
  libtet1.5-dev,
- libdolfin-dev (>= 2018.1),
- python3-ffc (>= 2018.1),
+ libdolfin-dev (>= 2019.1),
+ python3-ffc (>= 2019.1),
  python3-numpy,
  python3-petsc4py,
  python3-slepc4py,
  libproj-dev
-Standards-Version: 4.2.1
-X-Python3-Version: >= 3.5
+Standards-Version: 4.5.0
 Homepage: http://fenicsproject.org
 Vcs-Git: https://salsa.debian.org/science-team/fenics/mshr.git
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/mshr
 
-Package: libmshr2018.1
+Package: libmshr2019.1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -40,7 +40,7 @@
 Package: libmshr-dev
 Section: libdevel
 Architecture: any
-Depends: libmshr2018.1 (= ${binary:Version}),
+Depends: libmshr2019.1 (= ${binary:Version}),
  libdolfin-dev (>= ${fenics:Upstream-Version}),
  python3-ffc (>= ${fenics:Upstream-Version}),
  cmake (>= 2.8.0),
@@ -58,7 +58,7 @@
 Section: python
 Architecture: any
 Depends: libmshr-dev (= ${binary:Version}),
- libmshr2018.1 (= ${binary:Version}),
+ libmshr2019.1 (= ${binary:Version}),
  python3-dolfin (>= ${fenics:Upstream-Version}),
  dolfin-bin (>= ${fenics:Upstream-Version}),
  python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,7 @@
 #CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
 #LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
 
+DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
 
 MSHR_HOME = $(CURDIR)/$(DEB_SRCDIR)
@@ -24,17 +25,28 @@
 FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
 FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )
 
-# dolfin has a strict dependency on the pybind11 version it was built against,
+# dolfin depends on the pybind11 version it was built against,
 # if pybind11.h will be used in C++ code fragments in python scripts.
+# But pybind11 follows semantic versioning, so should have backwards compatibility
+# with minor and patch version updates.
 # Extract pybind11 version from pybind11-dev
 PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
 # extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
 PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
+PYBIND11_X_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\([^.]*\).*/\1/")
 PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
-PYBIND11_Z_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\2/")
-PYBIND11_NEXT_UPSTREAM_VERSION=$(PYBIND11_X_Y_VERSION).$(shell echo $$(( $(PYBIND11_Z_VERSION) + 1 )) )
+PYBIND11_VERSION=$(PYBIND11_X_Y_VERSION)
+PYBIND11_NEXT_VERSION=$(shell echo $$(( $(PYBIND11_X_VERSION) + 1 )) )
 
-# strip -g from dpkg-buildflags to reduce memory requirements of the build (needed to build on Debian 32 bit and on ubuntu)
+# some arches (mostly 32 bit) don't provide enough memory to build with debug symbols
+ARCH_NO_DEBUG_SYMBOLS := armhf i386 mips64el mipsel hppa m68k powerpc x32
+ifeq ($(findstring $(DEB_BUILD_ARCH),$(ARCH_NO_DEBUG_SYMBOLS)),)
+  MSHR_BUILDFLAGS := $(shell dpkg-buildflags --get CXXFLAGS )
+else
+# remove -g from build flags on weak arches
+  MSHR_BUILDFLAGS := $(shell dpkg-buildflags --get CXXFLAGS | sed 's/-g //' )
+endif
+
 CMAKE_OPTS := \
 	-D CMAKE_BUILD_TYPE:STRING=Release \
 	-D BUILD_SHARED_LIBS:BOOL=ON \
@@ -44,7 +56,7 @@
 	-D CMAKE_SKIP_RPATH:BOOL=ON \
 	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
 	-D INSTALL_LIB_DIR:PATH=lib/$(DEB_BUILD_MULTIARCH) \
-	-D CMAKE_CXX_FLAGS:STRING="-fpermissive $(shell dpkg-buildflags --get CXXFLAGS | sed 's/-g //' )" \
+	-D CMAKE_CXX_FLAGS:STRING="-fpermissive $(MSHR_BUILDFLAGS)" \
 	$(MSHR_HOME)
 
 ifeq (,$(DISTRIBUTION))
@@ -57,7 +69,8 @@
 
 %:
 	dh $@ --buildsystem=cmake \
-	      --with python3
+	      --with python3 \
+	      --no-parallel
 
 override_dh_auto_clean:
 	dh_auto_clean
@@ -78,11 +91,20 @@
 
 override_dh_gencontrol:
 	dh_gencontrol -- -Vfenics:Upstream-Version=$(FENICS_VERSION) \
-		-Vpybind11:Upstream-Version=$(PYBIND11_UPSTREAM_VERSION) -Vpybind11:Next-Upstream-Version=$(PYBIND11_NEXT_UPSTREAM_VERSION)
+		-Vpybind11:Upstream-Version=$(PYBIND11_VERSION) -Vpybind11:Next-Upstream-Version=$(PYBIND11_NEXT_VERSION)
 
-# debug symbols (-g) have been switched off in CMAKE_OPTS, so no point building dbgsym packages
+# debug symbols (-g) have been switched off in CMAKE_OPTS for some arches, so no point building dbgsym packages
 override_dh_strip:
-	dh_strip --no-automatic-dbgsym
+	case " $(ARCH_NO_DEBUG_SYMBOLS) " in \
+	    *\ $(DEB_HOST_ARCH)\ *) dh_strip --no-automatic-dbgsym;; \
+	    *) dh_strip;; \
+	esac
+
+override_dh_dwz:
+	case " $(ARCH_NO_DEBUG_SYMBOLS) " in \
+	    *\ $(DEB_HOST_ARCH)\ *) echo "skipping dh_dwz since debug symbols (-g) have been switched off for $(DEB_HOST_ARCH)";; \
+	    *) dh_dwz;; \
+	esac
 
 #override_dh_shlibdeps:
 #	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

## mshr 2019.2.0~git20200213.8895485+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 cmake_minimum_required(VERSION 3.5)
 
 project( MSHR )
-set(MSHR_VERSION_RELEASE 1)
+set(MSHR_VERSION_RELEASE 0)
 set(MSHR_VERSION_MAJOR "2019")
-set(MSHR_VERSION_MINOR "1")
+set(MSHR_VERSION_MINOR "2")
 set(MSHR_VERSION_MICRO "0")
 set(MSHR_VERSION "${MSHR_VERSION_MAJOR}.${MSHR_VERSION_MINOR}.${MSHR_VERSION_MICRO}")
 if (NOT MSHR_VERSION_RELEASE)
@@ -91,7 +91,6 @@
 add_definitions("${EXTERNAL_DEFINITIONS}")
 
 find_package(DOLFIN REQUIRED)
-include_directories(${DOLFIN_PYTHON_INCLUDE_DIRS})
 include(${DOLFIN_USE_FILE})
 
 # Set installation directories
@@ -196,8 +195,8 @@
 ### add cmake configuration file ###
 
 # common for both config files
-set(CONF_EXTERNAL_INCLUDE_DIRS "${DOLFIN_PYTHON_INCLUDE_DIRS};${DOLFIN_INCLUDE_DIRS};${DOLFIN_3RD_PARTY_INCLUDE_DIRS}")
-set(CONF_EXTERNAL_LIBRARIES "${DOLFIN_PYTHON_LIBRARIES};${DOLFIN_LIBRARIES};${DOLFIN_3RD_PARTY_LIBRARIES}")
+set(CONF_EXTERNAL_INCLUDE_DIRS "${DOLFIN_INCLUDE_DIRS};${DOLFIN_3RD_PARTY_INCLUDE_DIRS}")
+set(CONF_EXTERNAL_LIBRARIES "${DOLFIN_LIBRARIES};${DOLFIN_3RD_PARTY_LIBRARIES}")
 set(CONF_CXX_DEFINITIONS "${DOLFIN_CXX_DEFINITIONS}")
 string(REPLACE "\"" "\\\"" CONF_CXX_DEFINITIONS "${CONF_CXX_DEFINITIONS}")
 set(CONF_CXX_FLAGS "${DOLFIN_CXX_FLAGS}")
@@ -218,8 +217,8 @@
   "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshr-config.cmake" @ONLY)
 
 # Install the FooBarConfig.cmake and FooBarConfigVersion.cmake
-install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshrConfig.cmake" DESTINATION "${SHARE_DIR}/cmake" COMPONENT dev)
-install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshr-config.cmake" DESTINATION "${SHARE_DIR}/cmake" COMPONENT dev)
+install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshrConfig.cmake" DESTINATION "${INSTALL_LIB_DIR}/cmake/mshr" COMPONENT dev)
+install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshr-config.cmake" DESTINATION "${INSTALL_LIB_DIR}/cmake/mshr" COMPONENT dev)
 #install(FILES "Use-mshr.cmake" DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)

=== debian/changelog ===
mshr (2019.2.0~git20200213.8895485+dfsg1-2) unstable; urgency=medium

  * python3-mshr Depends: python3-dolfin-real
    (rather than common python3-dolfin)
  * debhelper compatibility level 13

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Aug 2020 01:21:17 +0800

mshr (2019.2.0~git20200213.8895485+dfsg1-1) unstable; urgency=medium

  * New upstream snapshot.
  - applies debian patches:
     build_CGAL_4.14.patch
     build_python.patch
     cmake_config_in_lib.patch
     demos_update.patch
     depython_main_build.patch
     pybind11_register.patch

 -- Drew Parsons <dparsons@debian.org>  Tue, 21 Apr 2020 14:41:30 +0800

mshr (2019.2.0~git20190418.010d802+dfsg1-1) experimental; urgency=medium

  * new upstream snapshot (2019.2)
  * Standards-Version: 4.5.0
  * add debian patches:
    - enable_CGAL5_CXX14.patch enables build with CGAL 5
      and builds with C++14 since std::enable_if is required by CGAL 5
    - build_CGAL5.patch updates to CGAL 5 API
    - pybind11_register.patch registers CSGCGALDomain3D::num_holes for
      python module, enabling test-fuzzypointmap.py to pass
      (update test_controls.patch)

 -- Drew Parsons <dparsons@debian.org>  Sat, 01 Feb 2020 16:44:38 +0800

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: mshr
 Section: math
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Johannes Ring <johannr@simula.no>, Drew Parsons <dparsons@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  python3-all-dev,
  dh-python,
  python3-setuptools,
@@ -14,8 +13,8 @@
  libgmp-dev,
  libcgal-dev (>= 4.13),
  libtet1.5-dev,
- libdolfin-dev (>= 2019.1),
- python3-ffc (>= 2019.1),
+ libdolfin-dev (>= 2019.2),
+ python3-ffc (>= 2019.2),
  python3-numpy,
  python3-petsc4py,
  python3-slepc4py,
@@ -25,7 +24,7 @@
 Vcs-Git: https://salsa.debian.org/science-team/fenics/mshr.git
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/mshr
 
-Package: libmshr2019.1
+Package: libmshr2019.2
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -40,7 +39,7 @@
 Package: libmshr-dev
 Section: libdevel
 Architecture: any
-Depends: libmshr2019.1 (= ${binary:Version}),
+Depends: libmshr2019.2 (= ${binary:Version}),
  libdolfin-dev (>= ${fenics:Upstream-Version}),
  python3-ffc (>= ${fenics:Upstream-Version}),
  cmake (>= 2.8.0),
@@ -58,12 +57,12 @@
 Section: python
 Architecture: any
 Depends: libmshr-dev (= ${binary:Version}),
- libmshr2019.1 (= ${binary:Version}),
- python3-dolfin (>= ${fenics:Upstream-Version}),
+ libmshr2019.2 (= ${binary:Version}),
+ python3-dolfin-real (>= ${fenics:Upstream-Version}),
  dolfin-bin (>= ${fenics:Upstream-Version}),
  python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
  ${python3:Depends},
- ${shlibs:Depends}, 
+ ${shlibs:Depends},
  ${misc:Depends}
 Description: Python 3 interface for mshr
  mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries

## mshr 2019.2.0~git20200924.c27eb18%2Bdfsg1

=== debian/changelog ===
mshr (2019.2.0~git20200924.c27eb18+dfsg1-7build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 18:02:23 +0000

mshr (2019.2.0~git20200924.c27eb18+dfsg1-7) unstable; urgency=medium

  * drop PETSC_ARCH from mshr.pth. It is only used for local build
    dirs, not in full installation, and interferes with python
    initialization when PETSc is in the middle of an ABI upgrade.

 -- Drew Parsons <dparsons@debian.org>  Fri, 12 Nov 2021 22:37:14 +0100

mshr (2019.2.0~git20200924.c27eb18+dfsg1-6) unstable; urgency=medium

  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Sat, 23 Oct 2021 21:09:15 +0200

mshr (2019.2.0~git20200924.c27eb18+dfsg1-5) unstable; urgency=medium

  * include PETSC_ARCH in mshr.pth to prevent mshr from interfering
    with new PETSc builds. mshr.pth checks
    $PETSC_DIR/$PETSC_ARCH/include/petscconf.h
  * fix parenthesis in python3-mshr description. Closes: #976011.
  * Standards-Version: 4.5.1

 -- Drew Parsons <dparsons@debian.org>  Wed, 13 Jan 2021 10:55:53 +1100

mshr (2019.2.0~git20200924.c27eb18+dfsg1-4) unstable; urgency=medium

  * fix quotes in i386 test condition.

 -- Drew Parsons <dparsons@debian.org>  Wed, 18 Nov 2020 03:46:38 +0800

mshr (2019.2.0~git20200924.c27eb18+dfsg1-3) unstable; urgency=medium

  * skip python unit test test-meshes on i386.
    mshr.UnitSphereMesh() hangs on i386. Use mshr.Sphere() instead
    (cf. deathstar demo).  Closes: #974561.

 -- Drew Parsons <dparsons@debian.org>  Tue, 17 Nov 2020 17:37:30 +0800

mshr (2019.2.0~git20200924.c27eb18+dfsg1-2) unstable; urgency=medium

  * install python modules in /usr/lib/mshr or /usr/lib/mshr64, not
    under PETSC_DIR. mshr does not use PETSc directly, but mshr.pth
    uses $PETSC_DIR/include/petscconf.h to select standard or 64-bit
    build.

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Nov 2020 13:37:22 +0800

mshr (2019.2.0~git20200924.c27eb18+dfsg1-1) unstable; urgency=medium

  * New upstream snapshot.
  * mark libmshr-dev-common and libmshr64-dev as Multi-Arch: same

 -- Drew Parsons <dparsons@debian.org>  Mon, 05 Oct 2020 00:15:24 +0800

mshr (2019.2.0~git20200213.8895485+dfsg1-4) unstable; urgency=medium

  * build against latest dolfin in unstable. Closes: #969635.
  * libmshr-dev-common Replaces, Breaks: libmshr-dev (<< ...-3).
    Closes: #970141.

 -- Drew Parsons <dparsons@debian.org>  Sun, 13 Sep 2020 02:10:27 +0800

mshr (2019.2.0~git20200213.8895485+dfsg1-3) experimental; urgency=medium

  * build 64 bit packages (supporting 64-bit dolfin)
    python3-mshr64, libmshr64-dev, libmshr64-2019.2
    - debian patch lib_rename.patch enables setting of soname to
      mshr64 rather than mshr (setting LIB_NAME_EXT in cmake,
      and MSHR_LIB_NAME_EXT in mshrConfig.cmake for client programs,
      cmake -DMSHR_LIB_NAME_EXT=64 to invoke libmshr64)
      Also uses DOLFIN_LIB_NAME_EXT=64 to link libdolfin64.so
    - place common header files in libmshr-dev-common
    - Build-Depends: libdolfin64-dev (>= 2019.2.0~git20200218.027d9cc-15)
      (to ensure DOLFIN_LIB_NAME_EXT is available)
    - activate 64-bit build with environment variables (see README.Debian)
       PETSC_DIR=/usr/lib/petsc64 SLEPC_DIR=/usr/lib/slepc64
       MSHR_LIB_NAME_EXT=64 DOLFIN_LIB_NAME_EXT=64 

 -- Drew Parsons <dparsons@debian.org>  Sun, 30 Aug 2020 07:44:11 +0800
